%% UKAD RWNA PYTKIEJ WODY
% Parametry zagadnienia
g = 1;
x = [-5,5];
t = [0,3];      % dla duszych czasw powstanie "fala uderzeniowa"

% Warunek pocztkowy i brzegowy funkcji wysokoci nad dnem
u0 = @(x) 1+2*exp(-5*x.^2)/5;
uL = @(t) 1;
uR = @(t) 1;

% Warunek pocztkowy i brzegowy funkcji prdkoci
v0 = @(x) zeros(size(x));
vL = @(t) 0;
vR = @(t) 0;

% Parametry schematu rnicowego:
% warto na pocztek sprawdzi dziaanie dla h = 0.1 (szybko si liczy),
% ale eby uzyska "wiarygodne" wyniki, to naley dx zmiejszy do poziomu
% okoo 0.01 (liczy si wtedy znacznie duej).
lambda = 0.2;
h = 0.01;          

% Rozwizanie ukadu rwna:
tic
[u, v, X, T, M, N] = ...
    ShallowWaterSystem(g, u0, uL, uR, v0, vL, vR, t, x, lambda, h);
t0=toc;
%%
% Wywietlenie rozwizania
for n = 1:10:N
    subplot(1,2,1)
    plot(X,u(:,n));
    xlim([-5,5])
    ylim([0.9,1.3])
    title(['Wykres poziomu wody dla $t=',...
        num2str(T(n),'%5.2f'),'$'],'Interpreter','latex')
    xlabel('$x$','Interpreter','latex')
    ylabel('$u(t,x)$','Interpreter','latex')
    
    subplot(1,2,2)
    plot(X,v(:,n));
    xlim([-5,5])
    ylim([-0.3,0.3])
    title(['Wykres predkosci powierzchni wody dla $t=',...
        num2str(T(n),'%5.2f'),'$'],'Interpreter','latex')
    xlabel('$x$','Interpreter','latex')
    ylabel('$v(t,x)$','Interpreter','latex')
    
    pause(0.1)
end